/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* dgedi.f -- translated by f2c (version 19980913).
   You must link the resulting object file with the libraries:
	-lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__1 = 1;

/* Subroutine */ int dgedi_ (a, lda, n, ipvt, det, work, job)
     doublereal *a;
     integer *lda, *n, *ipvt;
     doublereal *det, *work;
     integer *job;
{
   /* System generated locals */
   integer a_dim1, a_offset, i__1, i__2;

   /* Local variables */
   static integer i__, j, k, l;
   static doublereal t;
   extern /* Subroutine */ int dscal_ (), dswap_ (), daxpy_ ();
   static integer kb, kp1, nm1;
   static doublereal ten;

/* ***BEGIN PROLOGUE  DGEDI */
/* ***DATE WRITTEN   780814   (YYMMDD) */
/* ***REVISION DATE  820801   (YYMMDD) */
/* ***CATEGORY NO.  D3A1,D2A1 */
/* ***KEYWORDS  DETERMINANT,DOUBLE PRECISION,FACTOR,INVERSE, */
/*             LINEAR ALGEBRA,LINPACK,MATRIX */
/* ***AUTHOR  MOLER, C. B., (U. OF NEW MEXICO) */
/* ***PURPOSE  Computes the determinant and inverse of a matrix using */
/*            factors computed by DGECO or DGEFA. */
/* ***DESCRIPTION */

/*     DGEDI computes the determinant and inverse of a matrix */
/*     using the factors computed by DGECO or DGEFA. */

/*     On Entry */

/*        A       DOUBLE PRECISION(LDA, N) */
/*                the output from DGECO or DGEFA. */

/*        LDA     INTEGER */
/*                the leading dimension of the array  A . */

/*        N       INTEGER */
/*                the order of the matrix  A . */

/*        IPVT    INTEGER(N) */
/*                the pivot vector from DGECO or DGEFA. */

/*        WORK    DOUBLE PRECISION(N) */
/*                work vector.  Contents destroyed. */

/*        JOB     INTEGER */
/*                = 11   both determinant and inverse. */
/*                = 01   inverse only. */
/*                = 10   determinant only. */

/*     On Return */

/*        A       inverse of original matrix if requested. */
/*                Otherwise unchanged. */

/*        DET     DOUBLE PRECISION(2) */
/*                determinant of original matrix if requested. */
/*                Otherwise not referenced. */
/*                Determinant = DET(1) * 10.0**DET(2) */
/*                with  1.0 .LE. DABS(DET(1)) .LT. 10.0 */
/*                or  DET(1) .EQ. 0.0 . */

/*     Error Condition */

/*        A division by zero will occur if the input factor contains */
/*        a zero on the diagonal and the inverse is requested. */
/*        It will not occur if the subroutines are called correctly */
/*        and if DGECO has set RCOND .GT. 0.0 or DGEFA has set */
/*        INFO .EQ. 0 . */

/*     LINPACK.  This version dated 08/14/78 . */
/*     Cleve Moler, University of New Mexico, Argonne National Lab. */

/*     Subroutines and Functions */

/*     BLAS DAXPY,DSCAL,DSWAP */
/*     Fortran DABS,MOD */
/* ***REFERENCES  DONGARRA J.J., BUNCH J.R., MOLER C.B., STEWART G.W., */
/*                 *LINPACK USERS  GUIDE*, SIAM, 1979. */
/* ***ROUTINES CALLED  DAXPY,DSCAL,DSWAP */
/* ***END PROLOGUE  DGEDI */

/*     COMPUTE DETERMINANT */

/* ***FIRST EXECUTABLE STATEMENT  DGEDI */
   /* Parameter adjustments */
   a_dim1 = *lda;
   a_offset = a_dim1 + 1;
   a -= a_offset;
   --ipvt;
   --det;
   --work;

   /* Function Body */
   if (*job / 10 == 0)
   {
      goto L70;
   }
   det[1] = 1.;
   det[2] = 0.;
   ten = 10.;
   i__1 = *n;
   for (i__ = 1; i__ <= i__1; ++i__)
   {
      if (ipvt[i__] != i__)
      {
         det[1] = -det[1];
      }
      det[1] = a[i__ + i__ * a_dim1] * det[1];
/*        ...EXIT */
      if (det[1] == 0.)
      {
         goto L60;
      }
    L10:
      if (abs (det[1]) >= 1.)
      {
         goto L20;
      }
      det[1] = ten * det[1];
      det[2] += -1.;
      goto L10;
    L20:
    L30:
      if (abs (det[1]) < ten)
      {
         goto L40;
      }
      det[1] /= ten;
      det[2] += 1.;
      goto L30;
    L40:
/* L50: */
      ;
   }
 L60:
 L70:

/*     COMPUTE INVERSE(U) */

   if (*job % 10 == 0)
   {
      goto L150;
   }
   i__1 = *n;
   for (k = 1; k <= i__1; ++k)
   {
      a[k + k * a_dim1] = 1. / a[k + k * a_dim1];
      t = -a[k + k * a_dim1];
      i__2 = k - 1;
      dscal_ (&i__2, &t, &a[k * a_dim1 + 1], &c__1);
      kp1 = k + 1;
      if (*n < kp1)
      {
         goto L90;
      }
      i__2 = *n;
      for (j = kp1; j <= i__2; ++j)
      {
         t = a[k + j * a_dim1];
         a[k + j * a_dim1] = 0.;
         daxpy_ (&k, &t, &a[k * a_dim1 + 1], &c__1, &a[j * a_dim1 + 1], &c__1);
/* L80: */
      }
    L90:
/* L100: */
      ;
   }

/*        FORM INVERSE(U)*INVERSE(L) */

   nm1 = *n - 1;
   if (nm1 < 1)
   {
      goto L140;
   }
   i__1 = nm1;
   for (kb = 1; kb <= i__1; ++kb)
   {
      k = *n - kb;
      kp1 = k + 1;
      i__2 = *n;
      for (i__ = kp1; i__ <= i__2; ++i__)
      {
         work[i__] = a[i__ + k * a_dim1];
         a[i__ + k * a_dim1] = 0.;
/* L110: */
      }
      i__2 = *n;
      for (j = kp1; j <= i__2; ++j)
      {
         t = work[j];
         daxpy_ (n, &t, &a[j * a_dim1 + 1], &c__1, &a[k * a_dim1 + 1], &c__1);
/* L120: */
      }
      l = ipvt[k];
      if (l != k)
      {
         dswap_ (n, &a[k * a_dim1 + 1], &c__1, &a[l * a_dim1 + 1], &c__1);
      }
/* L130: */
   }
 L140:
 L150:
   return 0;
}                                       /* dgedi_ */
