/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
int proc_free (void)
{
   /* free the data structures defined in parsepars.h */

   void *p_nxt, *p_nxl;
   UNLNKD_PTR p_unl;
   SIM_PTR p_sim;
   MAP_PTR p_map;
/* VMAP_PTR p_vmp; */
   LOCUS_PTR p_loc;
   MEANS_PTR p_gmn;
   VARI_PTR p_var;
   MARKDAT_PTR p_mrk;
   PROBGAM_PTR p_prb;
   LOCWND_PTR p_wnd;
   TLIST_PTR p_trl;
   PRNTMAP_PTR p_prt;
   PDIST_PTR p_prl;
   int   sx;

   p_unl = first_unlnkd_node;
   while (p_unl)                        /* unlnkd_node */
   {
      p_nxt = p_unl->p_next;
      free (p_unl);
      p_unl = p_nxt;
   }
   first_unlnkd_node = NULL;

   p_sim = first_sim_node;              /* sim_node */
   while (p_sim)
   {
      p_nxt = p_sim->p_next;
      if (p_sim->p_mark)
         free (p_sim->p_mark);
      free (p_sim);
      p_sim = p_nxt;
   }
   first_sim_node = NULL;

   for (sx = FEM; sx <= AVG; ++sx)      /* marker map_node & dist_list */
   {
      p_map = first_mark_map_node[sx];
      while (p_map)
      {
         p_nxt = p_map->p_next;
         if (p_map->p_dist)
            free (p_map->p_dist);
         free (p_map);
         p_map = p_nxt;
      }
      first_mark_map_node[sx] = NULL;
   }
   for (sx = FEM; sx <= AVG; ++sx)      /* trait map_node & dist_list */
   {
      p_map = first_trait_map_node[sx];
      while (p_map)
      {
         p_nxt = p_map->p_next;
         if (p_map->p_dist)
            free (p_map->p_dist);
         free (p_map);
         p_map = p_nxt;
      }
      first_trait_map_node[sx] = NULL;
   }

/* ************** REVISE   */
#ifdef NEWCODE

   for (sx = FEM; sx <= AVG; ++sx)      /* trait vmap_node & trait pos */
   {
      p_vmp = first_trait_vmap_node[sx];
      while (p_vmp)
      {
         p_nxt = p_vmp->p_next;
         if (p_vmp->p_prop)
            free (p_vmp->p_prop);
         if (p_vmp->p_dist)
            free (p_vmp->p_dist);
         if (p_vmp->p_rf)
            free (p_vmp->p_rf);
         free (p_vmp);
         p_vmp = p_nxt;
      }
      first_trait_vmap_node[sx] = NULL;
   }
/*                ******************** */
#endif

   p_loc = first_mark_locus_node;       /* mark locus_node */
   while (p_loc)
   {
      p_nxt = p_loc->p_next;
      if ((p_loc->p_freq_node->no_loci -= 1) == 0) /* decrement no. loci */
      {                                 /* remove freq_node if no ptrs    */
         free (p_loc->p_freq_node->p_freq);
         free (p_loc->p_freq_node);
      }
      free (p_loc);
      p_loc = p_nxt;
   }
   first_mark_locus_node = NULL;

   p_loc = first_trait_locus_node;      /* trait locus_node */
   while (p_loc)
   {
      p_nxt = p_loc->p_next;
      if ((p_loc->p_freq_node->no_loci -= 1) == 0)
      {
         free (p_loc->p_freq_node->p_freq);
         free (p_loc->p_freq_node);
      }
      free (p_loc);
      p_loc = p_nxt;
   }
   first_trait_locus_node = NULL;

   p_gmn = first_means_node;            /* means_node */
   while (p_gmn)
   {
      p_nxt = p_gmn->p_next;
      free (p_gmn);
      p_gmn = p_nxt;
   }
   first_means_node = NULL;

   p_var = first_addi_node;             /* additive vari_node */
   while (p_var)
   {
      p_nxt = p_var->p_next;
      free (p_var);
      p_var = p_nxt;
   }
   first_addi_node = NULL;

   p_var = first_resi_node;             /* residual vari_node */
   while (p_var)
   {
      p_nxt = p_var->p_next;
      free (p_var);
      p_var = p_nxt;
   }
   first_resi_node = NULL;

   p_mrk = first_markdat_node;          /* markdat_node */
   while (p_mrk)
   {
      p_nxt = p_mrk->p_next;
      if (p_mrk->p_obs)
         free (p_mrk->p_obs);
      if (p_mrk->p_alls)
         free (p_mrk->p_alls);
      free (p_mrk);
      p_mrk = p_nxt;
   }
   first_markdat_node = NULL;

   p_prb = first_probgam_node;          /* probgam_node */
   while (p_prb)
   {
      p_nxt = p_prb->p_next;
      if (p_prb->p_pglist)
         free (p_prb->p_pglist);
      free (p_prb);
      p_prb = p_nxt;
   }
   first_probgam_node = NULL;

   p_wnd = first_locwind_node;          /* locwind_node */
   while (p_wnd)
   {
      p_nxt = p_wnd->p_next;
      free (p_wnd);
      p_wnd = p_nxt;
   }
   first_locwind_node = NULL;

   /* free the data structures defined in parsedrop.h */

   p_trl = first_tlist_node;            /* tlist node */
   while (p_trl)
   {
      p_nxt = p_trl->p_next;
      free (p_trl);
      p_trl = p_nxt;
   }
   first_tlist_node = NULL;

   for (sx = FEM; sx <= AVG; ++sx)      /* printmap_node */
   {
      p_prt = first_prntmap_node[sx];
      while (p_prt)
      {
         p_nxt = p_prt->p_next;
         p_prl = p_prt->p_locus;
         while (p_prl)
         {
            p_nxl = p_prl->p_next;
            free (p_prl);
            p_prl = p_nxl;
         }
         free (p_prt);
         p_prt = p_nxt;
      }
      first_prntmap_node[sx] = NULL;
   }

   return TRUE;
}
