/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* $Id: alloc_array.c,v 1.5 2006-08-31 23:44:53 thompson Exp $ */

#include "stuff.h"

int **alloc_int2d (int dim1, int dim2)
{
   int   i, j;
   int **array2d = 0;
   array2d = malloc (dim1 * sizeof (int *));
   alloc_chk (WHERE, array2d);
   for (i = 0; i < dim1; ++i)
   {
      array2d[i] = malloc (dim2 * sizeof (int));
      alloc_chk (WHERE, array2d[i]);
      for (j = 0; j < dim2; ++j)
      {
         array2d[i][j] = 0;
      }
   }
   return array2d;
}

int ***alloc_int3d (int dim1, int dim2, int dim3)
{
   int   i, j, k;
   int ***array3d = 0;
   array3d = malloc (dim1 * sizeof (int **));
   alloc_chk (WHERE, array3d);
   for (i = 0; i < dim1; ++i)
   {
      array3d[i] = malloc (dim2 * sizeof (int *));
      alloc_chk (WHERE, array3d[i]);
      for (j = 0; j < dim2; ++j)
      {
         array3d[i][j] = malloc (dim3 * sizeof (int));
         alloc_chk (WHERE, array3d[i][j]);
         for (k = 0; k < dim3; ++k)
         {
            array3d[i][j][k] = 0;
         }
      }
   }
   return array3d;
}

double **alloc_dbl2d (int dim1, int dim2)
{
   int   i, j;
   double **array2d = 0;
   array2d = malloc (dim1 * sizeof (double *));
   alloc_chk (WHERE, array2d);
   for (i = 0; i < dim1; ++i)
   {
      array2d[i] = malloc (dim2 * sizeof (double));
      alloc_chk (WHERE, array2d[i]);
      for (j = 0; j < dim2; ++j)
      {
         array2d[i][j] = 0.0;
      }
   }
   return array2d;
}

double ***alloc_dbl3d (int dim1, int dim2, int dim3)
{
   int   i, j, k;
   double ***array3d = 0;

   array3d = malloc (dim1 * sizeof (double **));
   alloc_chk (WHERE, array3d);
   for (i = 0; i < dim1; ++i)
   {
      array3d[i] = malloc (dim2 * sizeof (double *));
      alloc_chk (WHERE, array3d[i]);
      for (j = 0; j < dim2; ++j)
      {
         array3d[i][j] = malloc (dim3 * sizeof (double));
         alloc_chk (WHERE, array3d[i][j]);
         for (k = 0; k < dim3; ++k)
         {
            array3d[i][j][k] = 0.0;
         }
      }
   }
   return array3d;
}

void free_1d (void **array)
{
   if (*array)
      free (*array);
   *array = 0;

   return;
}

void free_2d (void ***array, int dim1)
{
   int   i;
   if (*array)
   {
      for (i = 0; i < dim1; ++i)
      {
         if ((*array)[i])
         {
            free ((*array)[i]);
         }
      }
      free (*array);
   }
   *array = 0;
}

void free_3d (void ****array, int dim1, int dim2)
{
   int   i, j;
   if (*array)
   {
      for (i = 0; i < dim1; ++i)
      {
         if ((*array)[i])
         {
            for (j = 0; j < dim2; ++j)
            {
               if ((*array)[i][j])
               {
                  free ((*array)[i][j]);
               }
            }
            free ((*array)[i]);
         }
      }
      free (*array);
   }
   *array = 0;
}

/*********************************************************/
/*  routines to alloc int and dbl vectors transferred here: EAT May 2006 */
/*     Used by Liping's routines that were in MulMsample                 */

void al_int_vector (int **h, int n)
{
   *h = malloc (n * sizeof (int));
   alloc_chk (WHERE, *h);

   return;
}
void al_double_vector (double **h, int n)
{
   *h = malloc (n * sizeof (double));
   alloc_chk (WHERE, *h);

   return;
}
