/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
/* 
 compare the output from new_gauss_quant with that from gauss_quant in Peel 
 (just for testing, not for ordinary user)  YJS 05/12/2005
*/

#include "twoqtl.h"

static void setup_qdex (void);

void test_new_gauss_quant (double *y, double *log_prob)
{
   int   i;
   double *y_1_origin, old_prob;
   double new_prob = 0.0;

   for (i = 0; i < n_compnts; i++)
   {
      new_prob += log_prob[i];
      fprintf (stderr, "*** component %d log_prob = %e\n", i, log_prob[i]);
   }

   setup_qdex ();

   y_1_origin = (double *) malloc ((Nq + 1) * sizeof (double));
   alloc_chk (WHERE, y_1_origin);
   y_1_origin[0] = 0.0;

   /* 1-origin-index (required by gauss_quant) */
   memcpy (y_1_origin + 1, y, Nq * sizeof (double));

   old_prob = gauss_quant (0.0, y_1_origin, 1.0, 0);
   fprintf (stderr, "**** new %e old %e \n", new_prob, old_prob);

   free (y_1_origin);

   return;
}

void setup_qdex (void)
{
   /* note: qdex is allocated by input_qdat */

   int   j, index = 0;
   for (j = 0; j < pedsize; ++j)
      if (nghd[j].q_dat != NULL)
         qdex[j] = ++index;
      else
         qdex[j] = 0;

   return;
}
